<!DOCTYPE html>
<html lang="de">
<head>
  <title>Kurskatalog Metadaten Formular</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"/>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
  <!-- <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.13.1/js/bootstrap-select.min.js"></script> -->
  <!-- Latest compiled and minified CSS -->
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/css/bootstrap-select.min.css"/>

  <!-- jQuery Select2 -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.0/js/select2.full.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.0/css/select2.min.css"/>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/select2-bootstrap-theme/0.1.0-beta.10/select2-bootstrap.min.css"/>

  <!-- datepicker -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.10.0/js/bootstrap-datepicker.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.10.0/locales/bootstrap-datepicker.de.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.10.0/locales/bootstrap-datepicker.en-US.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.10.0/css/bootstrap-datepicker.min.css"/>

  <!--<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"/>-->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.6.0/css/all.min.css"/>  

  <!-- Latest compiled and minified JavaScript -->
  <script src="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/js/bootstrap-select.min.js"></script>

  <!-- (Optional) Latest compiled and minified JavaScript translation files -->
  <script src="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.9/dist/js/i18n/defaults-de_DE.min.js"></script>
  <script src="https://unpkg.com/i18next/dist/umd/i18next.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/js-yaml/4.1.0/js-yaml.min.js"></script>
  <style>
      body {
        background-color:rgb(231, 231, 231);
      }
      .btn-primary {
          background-color: #0A1F40;
          border: 0;
      }
      .btn-primary:disabled {
        background-color: gray;
      }
      .btn-outline-primary {
          color: #0A1F40;
          border-color: #0A1F40;
      }
      .btn-outline-primary:disabled {
          color: gray;
          border-color: gray;
      }
      .btn-outline-primary:not(:disabled):not(.disabled).active, .btn-outline-primary:not(:disabled):not(.disabled):active, .show > .btn-outline-primary.dropdown-toggle {
          background-color: #0A1F40;
          border-color: #0A1F40;
      }
      .btn-outline-primary:hover {
          background-color: #0A1F40;
          border-color: #0A1F40;
      }

      .main {
          margin-top: 40px;
          padding: 0 60px;
          margin-bottom: 50px;
          flex-grow: 1;
      }

      .input-dropdown {
          background: #F1F6DF;
          color: #0A1F40;
      }

      .card {
        box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
        background-color: white;
        padding: 30px;
        border-radius: 10px;
      }

      .shadow {
        box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
      }

      @media only screen and (min-width: 700px) {
        .split {
          display: flex;
          flex-direction: row;
          column-gap: 20px;
          padding: 10px;
        }
      }
      @media only screen and (max-width: 700px) {
        .metadataTabDisplay {
          display: none;
        }
      }

      .tab-display {
        padding: 10px;
        text-align: left;
      }

      .tab-display.active {
        font-weight: bold;
      }

      @media only screen and (min-width: 1400px) {
        .dualpane {
          display: flex;
          flex-direction: row;
          column-gap: 40px;
        }
      }

      @media only screen and (max-width: 1400px) {
        .dualpane {
          display: flex;
          flex-direction: column;
          row-gap: 40px;
        }
        .widescreen {
          display: none;
        }
      }

      @media only screen and (max-width: 1000px) {
        .metadataTabDisplay {
          display: none;
        }
      }

      .verticalLine {
        border-left: thin solid #cec6c6;
        width: 100%;
        margin-left: 0px;
      }
      .verticalLine a {
        margin-left: -18px;
        width: 100%;
        background-color:white;
      }

      .wrapper {
        display: flex;
        flex-direction: column;
        min-height: 100vh;
      }
  </style>

</head>
<body>

  <div class="wrapper">
    <nav class="navbar navbar-light bg-white shadow" style="display: flex; justify-content: space-between;">
      <div class="navbar-brand" >
        <img src="logo.svg" height="50" width="116" alt="LOGO">
      </div>
      <div>
        <h2 data-i18n="FORM_HEADING">Kurskatalog Metadaten Formular</h2>
      </div>
      <div class="form-inline">
        <form class="form-inline ml-auto mr-3">
          <button class="btn" type="button" data-toggle="modal" data-target="#importModal">Import</button>
        </form>
        <ul class="navbar-nav">
          <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="#" id="navbarLanguageDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              <span id="selectedLanguageLabel">DE</span>
            </a>
            <div class="dropdown-menu position-absolute dropdown-menu-right" aria-labelledby="navbarLanguageDropdown">
            </div>
          </li>
        </ul>
      </div>
    </nav>
    <!-- Modal -->
    <div class="modal fade" id="importModal" tabindex="-1" role="dialog" aria-labelledby="importModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Import</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <textarea rows="15" class="form-control" id="importData" placeholder="Daten" data-i18n-placeholder="LABEL_IMPORT_DATA_PLACEHOLDER"></textarea>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal" data-i18n="LABEL_CLOSE">Schließen</button>
            <button type="button" class="btn btn-primary" data-i18n="LABEL_IMPORT" onclick="importData()">Import</button>
          </div>
        </div>
      </div>
    </div>

    <div class="main">
      <form id="metadata-form" class="was-validated">
        <div class="dualpane">
          <!-- left side -->
          <div style="flex: 2;" class="card">
            <!-- tabs -->
            <div class="form-group">
              <div class="split" style="width: 100%;">
                <div class="metadataTabDisplay" style="flex: 1; width: 100%;">
                  <div id="tabDisplay" class="verticalLine">
                    <div id="metadataTab" class="nav" role="tablist" style="display: flex; flex-direction: column; margin-top: 0px; row-gap:30px; text-align:center;">
                    </div>
                  </div>
                </div>

                <div class="tab-content" id="metadataTabContent" style="flex: 4; width: 100%;">
              
                  <!-- Basic information -->
                  <div class="tab-pane meta-tab-pane fade show active" id="basic-info" role="tabpanel" aria-labelledby="basic-info-tab">

                    <!-- Title -->
                    <div class="form-group mt-3">
                      <label for="inputTitle" class="form-row col-form-label" data-i18n="LABEL_TITLE">Titel</label>
                      <div class="form-row">
                        <input type="text" class="form-control" id="inputTitle" placeholder="Titel"
                              data-i18n-placeholder="LABEL_TITLE" value="" oninput="generate()" required>
                        <div class="valid-feedback"></div>
                        <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
                      </div>
                    </div>
                    <!-- Link to course -->
                    <div class="form-group">
                      <label for="inputUrl" class="form-row col-form-label" data-i18n="LABEL_URL">URL</label>
                      <div class="form-row">
                        <input type="url" class="form-control" id="inputUrl" placeholder="URL" data-i18n-placeholder="LABEL_URL_PLACEHOLDER" value="" oninput="generate()" required>
                        <div class="valid-feedback"></div>
                        <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
                      </div>
                    </div>
                    <!-- Description -->
                    <div class="form-group">
                      <label for="inputDescription" class="form-row col-form-label"
                            data-i18n="LABEL_DESCRIPTION">Beschreibung</label>
                      <div class="form-row">
                        <textarea class="form-control" id="inputDescription" placeholder="Beschreibung" data-i18n-placeholder="LABEL_DESCRIPTION" oninput="generate()" required></textarea>
                        <div class="valid-feedback"></div>
                        <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
                      </div>
                    </div>
                    <!-- Subject -->
                    <div class="form-group">
                      <label for="inputSubjectOf" class="form-row col-form-label" data-i18n="LABEL_SUBJECT">Fach</label>
                      <div class="form-row">
                        <select data-style="input-dropdown" data-width="100%" class="selectpicker" id="inputSubjectOf" data-live-search="true" data-i18n-title="LABEL_CHOOSE" required>
                        </select>
                        <div class="valid-feedback"></div>
                        <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
                      </div>
                    </div>
                    <!-- Educational level -->
                    <div class="form-group">
                      <label for="inputEducationalLevel" class="form-row col-form-label" data-i18n="LABEL_EDUCATIONALLEVEL">Bildungsstufe</label>
                      <div class="form-row">
                        <select data-style="input-dropdown" data-width="100%" class="selectpicker" id="inputEducationalLevel" data-i18n-title="LABEL_EDUCATIONALLEVEL_CHOOSE">
                        </select>
                      </div>
                    </div>
                    <!-- Teaching language -->
                    <div class="form-group">
                      <label for="teachingLanguage" class="form-row col-form-label" data-i18n="LABEL_TEACHING_LANGUAGE">Sprache</label>
                      <div class="form-row">
                        <select data-style="input-dropdown" data-width="100%" class="selectpicker" id="teachingLanguage" data-i18n-title="LABEL_CHOOSE">
                        </select>
                        <div class="valid-feedback"></div>
                      </div>
                    </div>
                    <!-- Learning outcomes -->
                    <div class="form-group">
                      <label for="inputLearningOutcomes" class="form-row col-form-label" data-i18n="LABEL_LEARNING_OUTCOMES">Lernziele</label>
                      <div class="form-row">
                        <textarea class="form-control" id="inputLearningOutcomes" placeholder="Lernziele" data-i18n-placeholder="LABEL_LEARNING_OUTCOMES" oninput="generate()" required></textarea>
                        <div class="valid-feedback"></div>
                        <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
                      </div>
                    </div>
                    <!-- Qualification requirements -->
                    <div class="form-group">
                      <label for="inputQualificationRequirements" class="form-row col-form-label" data-i18n="LABEL_QUALIFICATION_REQUIREMENTS">Anforderungen</label>
                      <div class="form-row">
                        <textarea class="form-control" id="inputQualificationRequirements" placeholder="Lernziele" data-i18n-placeholder="LABEL_QUALIFICATION_REQUIREMENTS" oninput="generate()" required></textarea>
                        <div class="valid-feedback"></div>
                        <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
                      </div>
                    </div>
                  </div>

                  <!-- Course details -->
                  <div class="tab-pane meta-tab-pane fade" id="course-details" role="tabpanel" aria-labelledby="course-detail-tab">

                    <!-- Course code -->
                    <div class="form-group mt-3">
                      <label for="inputCourseCode" class="form-row col-form-label" data-i18n="LABEL_COUSE_CODE">Course code</label>
                      <div class="form-row">
                        <input type="text" class="form-control" id="inputCourseCode" placeholder="Code" data-i18n-placeholder="LABEL_COUSE_CODE_PLACEHOLDER" value="" oninput="generate()" required>
                        <div class="valid-feedback"></div>
                        <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
                      </div>
                    </div>
                    <!-- Mode of delivery -->
                    <div class="form-group">
                      <label for="inputModeOfDelivery" class="form-row col-form-label" data-i18n="LABEL_DELIVERY_MODE">Kursformat</label>
                      <div class="form-row">
                        <select data-style="input-dropdown" data-width="100%" class="selectpicker" id="inputModeOfDelivery" data-i18n-title="LABEL_DELIVERY_MODE_CHOOSE" >
                        </select>
                      </div>
                    </div>
                    <!-- Course workload -->
                    <div class="form-group">
                      <label for="inputCourseWorkload" class="form-row col-form-label" data-i18n="LABEL_COURSE_WORKLOAD">Arbeitsaufwand</label>
                      <div class="form-row">
                        <input type="text" class="form-control" id="inputCourseWorkload" placeholder="Arbeitsaufwand" data-i18n-placeholder="LABEL_COURSE_WORKLOAD" oninput="generate()" ></textarea>
                      </div>
                    </div>
                    <!-- Study load -->
                    <div class="form-group">
                      <label for="inputStudyLoad" class="form-row col-form-label" data-i18n="LABEL_STUDYLOAD">Lernumfang</label>
                      <div class="form-row">
                        <div class="col" style="flex-grow: 1;">
                          <input type="number" id="inputStudyLoad" data-i18n-title="LABEL_STUDYLOAD" class="form-control" data-width="80%" oninput="generate()" />
                        </div>
                        <div class="col" style="flex-grow: 1;">
                          <select data-style="input-dropdown" data-width="100%" class="selectpicker" id="inputStudyLoadUnit" data-i18n-title="LABEL_STUDYLOAD_UNIT" >
                          </select>
                        </div>
                      </div>
                    </div>
                    <!-- Course type -->
                    <div class="form-group">
                      <label for="inputCourseType" class="form-row col-form-label" data-i18n="LABEL_COURSE_TYPE">Kurstyp</label>
                      <div class="form-row">
                        <select data-style="input-dropdown" data-width="100%" class="selectpicker" id="inputCourseType" data-i18n-title="LABEL_CHOOSE" >
                        </select>
                      </div>
                    </div>
                    <!-- Location -->
                    <div class="form-group">
                      <label for="inputCourseLocation" class="form-row col-form-label" data-i18n="LABEL_COURSE_LOCATION">Ort</label>
                      <div class="row form-row">
                        <ul class="list-group col" id="location-list">
                          <li class="list-group-item">
                            <button type="button" onclick="addLocation()" class="btn btn-primary mt-1"><i class="fa fa-plus"></i> <span
                                    data-i18n="LABEL_LOCATION_ADD">Adresse hinzufügen</span></button>
                          </li>
                        </ul>
                      </div>
                    </div>
                    <!-- Audience -->
                    <div class="form-group">
                      <label for="inputAudience" class="form-row col-form-label" data-i18n="LABEL_AUDIENCE">Zielgruppe</label>
                      <div class="form-row">
                        <select data-style="input-dropdown" data-width="100%" class="selectpicker" id="inputAudience" data-i18n-title="LABEL_CHOOSE" >
                        </select>
                      </div>
                    </div>
                    <!-- Keywords -->
                    <div class="form-group">
                      <label for="inputTags" class="form-row col-form-label" data-i18n="LABEL_KEYWORDS">Schlagworte</label>
                      <div class="form-row">
                        <input type="text" class="form-control" id="inputTags" placeholder="Komma getrennte Liste von Schlagworten"
                              data-i18n-placeholder="LABEL_KEYWORDS_PLACEHOLDER" value="" oninput="generate()" >
                      </div>
                    </div>
                    <!-- Access conditions -->
                    <div class="form-group">
                      <label for="inputAccessConditions" class="form-row col-form-label" data-i18n="LABEL_ACCESS_CONDITIONS">Zugangsbedingungen</label>
                      <div class="form-row">
                        <input type="text" class="form-control" id="inputAccessConditions" placeholder="Zugangsbedingungen"
                              data-i18n-placeholder="LABEL_ACCESS_CONDITIONS_PLACEHOLDER" value="" oninput="generate()">
                      </div>
                    </div><!-- Start date -->
                    <div class="form-group" id="dateFormGroup">
                      <label for="startDate" class="form-row col-form-label" data-i18n="LABEL_START_DATE">Startdatum</label>
                      <div class="form-row input-group date" id="startdatepicker" data-target-input="nearest">
                        <input type="text" id="startDatepickerInput" class="form-control datepicker-input" data-target="#startdatepicker" oninput="generate()" />
                        <div class="input-group-append" data-target="#startdatepicker" data-toggle="datepicker">
                            <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                        </div>
                      </div>
                    </div>
                    <!-- End date -->
                    <div class="form-group" id="dateFormGroup">
                      <label for="endDate" class="form-row col-form-label" data-i18n="LABEL_END_DATE">Enddatum</label>
                      <div class="form-row input-group date" id="enddatepicker" data-target-input="nearest">
                        <input type="text" id="endDatepickerInput" class="form-control datepicker-input" data-target="#enddatepicker" oninput="generate()" />
                        <div class="input-group-append" data-target="#enddatepicker" data-toggle="datepicker">
                            <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                        </div>
                      </div>
                    </div>
                    <!-- Registration deadline -->
                    <div class="form-group" id="dateFormGroup">
                      <label for="enrollEndDate" class="form-row col-form-label" data-i18n="LABEL_ENROLL_END_DATE">Ende Registrierung</label>
                      <div class="form-row input-group date" id="enrollenddatepicker" data-target-input="nearest">
                        <input type="text" id="enrollEndDatepickerInput" class="form-control datepicker-input" data-target="#enrollenddatepicker" oninput="generate()" />
                        <div class="input-group-append" data-target="#enrollenddatepicker" data-toggle="datepicker">
                            <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                        </div>
                      </div>
                    </div>
                    <!-- Course fees -->
                    <div class="form-group">
                      <label for="inputFreeAccess" class="form-row col-form-label" data-i18n="LABEL_ACCESS">Kosten</label>
                      <div class="form-row">
                        <div class="col-auto" id="freeAccess" style="padding-top: 1ch;">
                          <input type="radio" value="freeAccess" name="radioAccess" id="radioAccessFree" onclick="changeAccessCost()" oninput="generate()" checked>
                        </div>
                        <div class="col-auto" style="padding-top: 1ch">
                          <label data-i18n="LABEL_FREE_ACCESS">Kostenlos</label>
                        </div>
                      </div>
                      <div class="form-row">
                        <label for="inputFreeAccess" class="form-row col-form-label"></label>
                        <div class="col-auto" id="nonFreeAccess" style="padding-top: 1ch">
                          <input type="radio" value="nonFreeAccess" name="radioAccess" id="radioAccessNotFree" oninput="generate()" onclick="changeAccessCost()">
                        </div>
                        <div class="col-auto">
                          <input type="number" step="0.01" id="inputAccessCost" data-i18n-placeholder="LABEL_FREE_ACCESS_PLACEHOLDER" class="form-control" oninput="generate()" />
                        </div>
                        <div class="col-auto">
                          <select data-style="input-dropdown" class="selectpicker" id="inputAccessCostCurrency" data-i18n-title="LABEL_CURRENCY">
                          </select>
                        </div>
                      </div>
                    </div>
                    <!-- Resources -->
                    <div class="form-group">
                      <label for="resource-list" class="form-row col-form-label" data-i18n="LABEL_RESOURCES">Ressourcen</label>
                      <div class="row form-row">
                        <ul class="list-group col" id="resource-list">
                          <li class="list-group-item">
                            <input type="text" class="form-control inputResource" id="inputResource" placeholder="Ressource"
                            data-i18n-placeholder="LABEL_RESOURCE" value="" oninput="generate()" />
                          </li>
                          <li class="list-group-item">       
                            <button type="button" onclick="addResource()" class="btn btn-primary"><i class="fa fa-plus"></i> <span
                                    data-i18n="LABEL_RESOURCE_ADD">Ressource hinzufügen</span></button>
                          </li>
                        </ul>
                      </div>
                    </div>
                  </div>

                  <!-- Organization -->
                  <div class="tab-pane meta-tab-pane fade" id="organization" role="tabpanel" aria-labelledby="organization-tab">

                    <!-- Organization -->
                    <div class="form-group mt-3">
                      <div class="row form-row">
                        <ul class="list-group col" id="organization-list">
                          <li class="list-group-item">
                            <button type="button" onclick="addOrganization()" class="btn btn-primary"><i class="fa fa-plus"></i> <span data-i18n="LABEL_ORGANIZATION_ADD"></span></button>
                          </li>
                        </ul>
                      </div>
                    </div>
                  </div>

                  <!-- Coordinators -->
                  <div class="tab-pane meta-tab-pane fade" id="coordinator" role="tabpanel" aria-labelledby="coordinator-tab">

                    <!-- Coordinator -->
                    <div class="form-group row mt-3">
                      <div class="col-sm form-row">
                        <ul class="list-group col" id="coordinator-list">
                          <li class="list-group-item">
                            <button type="button" onclick="addCoordinator()" class="btn btn-primary"><i class="fa fa-plus"></i> <span
                                    data-i18n="LABEL_COORDINATOR_ADD">KoordinatorIn hinzufügen</span></button>
                          </li>
                        </ul>
                      </div>
                    </div>
                  </div>

                  <!-- Units -->
                  <div class="tab-pane meta-tab-pane fade" id="units" role="tabpanel" aria-labelledby="units-tab">

                    <!-- Units -->
                    <div class="form-group row mt-3">
                      <div class="col-sm form-row">
                        <ul class="list-group col" id="unit-list">
                          <li class="list-group-item">
                            <button type="button" onclick="addUnit()" class="btn btn-primary"><i class="fa fa-plus"></i> <span
                                    data-i18n="LABEL_UNIT_ADD">Einheit hinzufügen</span></button>
                          </li>
                        </ul>
                      </div>
                    </div>
                  </div>

                  <!-- Program -->
                  <div class="tab-pane meta-tab-pane fade" id="program" role="tabpanel" aria-labelledby="program-tab">

                    <!-- Program -->
                    <div class="form-group mt-3">
                      <div class="row form-row">
                        <ul class="list-group col" id="program-list">
                          <li class="list-group-item">
                            <button type="button" onclick="addProgram()" class="btn btn-primary"><i class="fa fa-plus"></i> <span
                                    data-i18n="LABEL_PROGRAM_ADD">Programm hinzufügen</span></button>
                          </li>
                        </ul>
                      </div>
                    </div>
                  </div>

                </div>
              </div>
            </div>
          </div>

          <!-- right side -->
          <div style="flex: 1;">
            <div class="card">
            <h3 style="text-align: center;" data-i18n="LABEL_METADATA_OUTPUT">Metadata output</h3>

            <div class="form-group mt-4">
              <ul class="nav nav-tabs" id="outputTab" role="tablist">
                <li class="nav-item" role="presentation">
                  <button class="nav-link active" id="yaml-tab" data-toggle="tab" data-target="#yaml" type="button" role="tab" aria-controls="yaml" aria-selected="true">YAML</button>
                </li>
                <li class="nav-item" role="presentation">
                  <button class="nav-link" id="json-tab" data-toggle="tab" data-target="#json" type="button" role="tab" aria-controls="json" aria-selected="false">JSON</button>
                </li>
              </ul>
              <div class="tab-content mt-1" id="outputTabContent">
                <div class="tab-pane fade show active" id="yaml" role="tabpanel" aria-labelledby="yaml-tab">
                  <div style="display: flex; justify-content: space-between;">
                    <button type="button" disabled onclick="copy_generated_output('yaml_output')" class="btn btn-primary my-2" id="button_copy_generated_output_yaml"><i class="fa fa-copy"></i> YAML <span data-i18n="LABEL_COPY">Kopieren</span></button>
                    <button type="button" onclick="resetForm()" class="btn btn-primary my-2"><i class="fa fa-rotate-left"></i> <span data-i18n="LABEL_RESET">Reset</span></button>
                  </div>
                  <textarea class="form-control" rows="15" id="yaml_output"></textarea>
                </div>
                <div class="tab-pane fade" id="json" role="tabpanel" aria-labelledby="json-tab">
                  <div style="display: flex; justify-content: space-between;">
                    <button type="button" disabled onclick="copy_generated_output('json_output')" class="btn btn-primary my-2" id="button_copy_generated_output_json"><i class="fa fa-copy"></i> JSON <span data-i18n="LABEL_COPY">Kopieren</span></button>
                    <button type="button" onclick="resetForm();" class="btn btn-primary my-2"><i class="fa fa-rotate-left"></i> <span data-i18n="LABEL_RESET">Reset</span></button>
                  </div>
                  <textarea class="form-control" rows="15" id="json_output"></textarea>
                </div>
              </div>
            </div>
          </div>
          </div>
        </div>
    </form>
    </div>

    <div id="copied_to_clipboard_toast" class="toast hide" role="alert" aria-live="assertive" aria-atomic="true">
      <div class="toast-body"><span data-i18n="LABEL_COPIED_TO_CLIPBOARD">In die Zwischenablage kopiert</span></div>
      <button type="button" class="btn-close me-2 m-auto" data-bs-dismiss="toast" aria-label="Close"></button>
    </div>

    <footer class="bg-light text-center">
      <div class="text-center p-3">
        GitLab:
        <a class="text-dark" href="https://gitlab.com/TIBHannover/course-catalogue/metadata-form/">https://gitlab.com/TIBHannover/course-catalogue/metadata-form/</a>
      </div>
    </footer>
  </div>
</div>

<script>
  init();
  var userLang = "en";

  async function init() {
    await loadVocabs();
    await i18nLoader();
    addCoordinator();
    addOrganization();
    addLocation();
    addProgram();
    addUnit();

    let tabs = [
      {
        "label": "LABEL_BASIC_INFORMATION",
        "tabName": "basic-info"
      },
      {
        "label": "LABEL_COURSE_DETAILS",
        "tabName": "course-details"
      },
      {
        "label": "LABEL_ORGANIZATION",
        "tabName": "organization"
      },
      {
        "label": "LABEL_COORDINATOR",
        "tabName": "coordinator"
      },
      {
        "label": "LABEL_UNITS",
        "tabName": "units"
      },
      {
        "label": "LABEL_PROGRAM",
        "tabName": "program"
      }
    ]

    buildTabs(tabs);
    createTabDisplay(tabs);

    $('#inputStudyLoadUnit').val("ects");
    $('#inputAccessCostCurrency').val("EUR");
    $('.selectpicker').on('change', function (e) {
      generate();
    });
    $('.selectpicker').selectpicker('refresh');

    userLang = navigator.language || navigator.userLanguage;
    if (userLang) {
      changeLanguage(userLang);
    }

    updateContent();
    generate();
  }

  let vocabInstitutions = [];
  let languageCodes = [];
  let subOrganizationTypes = [];

  function loadVocabs() {
    $(document).ready(function () {
      $.getJSON("vocabs/educationalLevel.json", function (result) {
        $.each(result, function (i, item) {
          $("#inputEducationalLevel").append('<option value="' + item + '" data-i18n="' + item + '"></option>');
        });
      });
      $.getJSON("vocabs/hcrt.json", function (result) {
        $.each(result, function (i, item) {
          $("#inputResourceType").append('<option value="' + item + '" data-i18n="' + item + '"></option>');
        });
      });
      $.getJSON("vocabs/language.json", function (result) {
        $.each(result, function (i, item) {
          $("#inputLanguage").append('<option value="' + item + '" data-i18n="' + item + '"></option>');
          $("#teachingLanguage").append('<option value="' + item + '" data-i18n="' + item + '"></option>');
        });
      });
      $.getJSON("vocabs/eulist-languages.json", function (result) {
        $.each(result, function (i, item) {
          let elem = document.getElementsByClassName("dropdown-menu-right")[0];
          let html = document.createElement("a");
          html.setAttribute("class", "dropdown-item");
          html.setAttribute("onclick", "changeLanguage('" + item + "')");
          html.innerHTML = `<span data-i18n="${item}">${item}</span>`;
          elem.appendChild(html);
        });
      });
      $.getJSON("vocabs/language-iso639-2.json", function (result) {
        languageCodes = result;
      });
      $.getJSON("vocabs/organizations.json", function (result) {
        vocabInstitutions = result;
      });
      $.getJSON("vocabs/subject.json", function (result) {
        $.each(result, function (i, item) {
          $("#inputSubjectOf").append('<option value="' + item + '" data-i18n="' + item + '"></option>');
        });
      });
      $.getJSON("vocabs/modeOfDelivery.json", function (result) {
        $.each(result, function (i, item) {
          $("#inputModeOfDelivery").append('<option value="' + item + '" data-i18n="' + item + '"></option>');
        });
      });
      $.getJSON("vocabs/studyLoadUnit.json", function (result) {
        $.each(result, function (i, item) {
          $("#inputStudyLoadUnit").append('<option value="' + item + '" data-i18n="' + item.toUpperCase() + '"></option>');
        });
      });
      $.getJSON("vocabs/subOrganizationType.json", function (result) {
        $.each(result, function (i, item) {
          subOrganizationTypes = result;
        });
      });
      $.getJSON("vocabs/courseType.json", function (result) {
        $.each(result, function (i, item) {
          $("#inputCourseType").append('<option value="' + item + '" data-i18n="' + item + '"></option>');
        });
      });
      $.getJSON("vocabs/audience.json", function (result) {
        $.each(result, function (i, item) {
          $("#inputAudience").append('<option value="' + item + '" data-i18n="' + item + '"></option>');
        });
      });
      $.getJSON("vocabs/currency.json", function (result) {
        $.each(result, function (i, item) {
          $("#inputAccessCostCurrency").append('<option value="' + item + '" data-i18n="' + item + '"></option>');
        });
      });
    });
  }

  function buildTabs(tabs) {
    for (let i=0; i < tabs.length; i++) {
      let header = createTabHeader(tabs[i]["label"], i > 0, i == tabs.length - 1);
      let tab = document.getElementById(tabs[i]["tabName"]);
      tab.insertBefore(header, tab.firstElementChild);
    }
  }

  function createTabHeader(tabLabel, hasPrevious, hasNext) {
    const item = document.createElement("div");
    item.setAttribute("class", "row");
    item.setAttribute("style", "justify-content: space-between;");

    item.innerHTML = `
      <div id="previousTab">
        <button id="previousTabButton" class="btn btn-outline-primary" onclick="previousTab()" ${hasPrevious? "" : "disabled" }> Previous </button>
      </div>
      <h3 style="text-align: center;" data-i18n=${tabLabel}>${tabLabel}</h3>
      <div id="nextTab" class="mr-3">
        <button id="nextTabButton" class="btn btn-outline-primary" onclick="nextTab()" ${hasNext? "disabled" : "" }> Next </button>
      </div>
    `;

    return item;
  }

  
  function createTabDisplay(tabs) {
    for (let i = 0; i < tabs.length; i++) {
      const item = document.createElement("a");
      item.setAttribute("class", i == 0 ? "active show nav-link tab-display" : "nav-link tab-display");
      item.setAttribute("id", tabs[i]["tabName"] + "-tab");
      item.setAttribute("onclick", "pressedTabButton(" + i + ")");
      item.setAttribute("data-toggle", "tab");
      item.setAttribute("data-target", "#" + tabs[i]["tabName"]);
      item.setAttribute("type", "button");
      item.setAttribute("role", "tab");
      item.setAttribute("aria-controls", tabs[i]["tabName"]);
      item.setAttribute("aria-selected", i == 0 ? "true" : "false");

      item.innerHTML = `
        <div class="row">
          <div class="col-sm-1">
            <i class="${i === 0 ? "fa" : "far"} fa-circle"></i>
          </div>
          <div class="col">
            <span data-i18n=${tabs[i]["label"]}>${tabs[i]["tabName"]}</span>
          </div>
        </div>
        `;

      document.getElementById("metadataTab").appendChild(item);
    }
  }

  function nextTab() {
    let tabButtonList = document.getElementById("metadataTab");
    let tabButtons = tabButtonList.getElementsByClassName("nav-link");
    let tabList = document.getElementById("metadataTabContent");
    let tabs = tabList.getElementsByClassName("meta-tab-pane");

    for (i = 0; i < tabs.length - 1; i++) {
      if (tabs[i].classList.contains("active")) {
          tabs[i].classList.remove("active");
          tabs[i].classList.remove("show");
          tabButtons[i].classList.remove("active");
          tabs[i+1].classList.add("active");
          tabs[i+1].classList.add("show");
          tabButtons[i+1].classList.add("active");
          document.getElementById("previousTabButton").disabled = false;
          pressedTabButton(i+1);
        if (i == tabs.length - 2) {
          document.getElementById("nextTabButton").disabled = true;
        }
        break;
      }
    }
  }

  function previousTab() {
    let tabButtonList = document.getElementById("metadataTab");
    let tabButtons = tabButtonList.getElementsByClassName("nav-link");
    let tabList = document.getElementById("metadataTabContent");
    let tabs = tabList.getElementsByClassName("meta-tab-pane");

    for (i = 0; i < tabs.length; i++) {
      if (tabs[i].classList.contains("active")) {
        if (i > 0) {
          tabs[i].classList.remove("active");
          tabs[i].classList.remove("show");
          tabButtons[i].classList.remove("active");
          tabs[i-1].classList.add("active");
          tabs[i-1].classList.add("show");
          tabButtons[i-1].classList.add("active");
          document.getElementById("nextTabButton").disabled = false;
          pressedTabButton(i-1);
          if (i - 1 == 0) {
            document.getElementById("previousTabButton").disabled = true;
          }
        }
        break;
      }
    }
  }

  function pressedTabButton(i) {
    let tabList = document.getElementById("metadataTabContent");
    let tabs = tabList.getElementsByClassName("meta-tab-pane");
    let tabButtonList = document.getElementById("metadataTab");
    let tabButtons = tabButtonList.getElementsByClassName("nav-link");

    if (i == 0) {
      document.getElementById("previousTabButton").disabled = true;
      document.getElementById("nextTabButton").disabled = false;
    } else if (i == tabs.length - 1) {
      document.getElementById("previousTabButton").disabled = false;
      document.getElementById("nextTabButton").disabled = true;
    } else {
      document.getElementById("previousTabButton").disabled = false;
      document.getElementById("nextTabButton").disabled = false;
    }
    
    for (let j = 0; j < tabs.length; j++) {
      let tabLink = tabButtons[j].getElementsByClassName("fa");
    
      if (tabLink.length > 0) {
        tabLink[0].classList.add("far");
        tabLink[0].classList.remove("fa");
        break;
      }
    }

    tabButtons[i].getElementsByClassName("far")[0].classList.add("fa");
    tabButtons[i].getElementsByClassName("far")[0].classList.remove("far");
  }

  function changeAccessCost() {
    if(document.getElementById("radioAccessFree").checked) {
      document.getElementById("inputAccessCost").disabled = true;
    } else {
      document.getElementById("inputAccessCost").disabled = false;
    }
    generate();
  }

  function splitKeywords(keywordString) {
    const keywords = keywordString.split(",");
    return keywords.map((k) => k.trim());
  }

  function changecoordinatorType(coordinatorListItem, type) {
    const personElements = coordinatorListItem.getElementsByClassName("person-element")
    for (let i = 0; i < personElements.length; i++) {
      personElements[i].style.display = type === "Person" ? "flex" : "none"
    }
    const organizationElements = coordinatorListItem.getElementsByClassName("organization-element")
    for (let i = 0; i < organizationElements.length; i++) {
      organizationElements[i].style.display = type === "Organization" ? "flex" : "none"
    }
  }

  function changeAffiliationType(coordinatorListItem, type) {
    const affiliationElements = coordinatorListItem.getElementsByClassName("inputAffiliation")
    for (const element of affiliationElements) {
      if (element.classList.contains("customAffiliation")) {
        element.disabled = type !== "custom";
      } else {
        element.disabled = type === "custom";
      }
    }
    $('.selectpicker').selectpicker('refresh');
  }

  function changeOrganizationType(coordinatorListItem, type) {
    /*if (type !== "custom") {
      document.getElementById("organizationTypeStandard").setAttribute("checked", "true");
    } else {
      document.getElementById("organizationTypeCustom").setAttribute("checked", "true");
    }*/

    const organizationElements = coordinatorListItem.getElementsByClassName("inputOrganization");
    for (const element of organizationElements) {
      if (element.classList.contains("customOrganization")) {
        element.disabled = type !== "custom";
      } else {
        element.disabled = type === "custom";
      }
    }
    $('.selectpicker').selectpicker('refresh');
  }

  function addProgram(name = "", id = "", abbreviation = "", description = "", teachingLanguage = "") {
    const programList = document.getElementById("program-list");
    const item = document.createElement("li");
    item.setAttribute("class", "list-group-item");

    let options = $("#teachingLanguage").html();

    item.innerHTML = `
    <div class="form-group">
      <div class="form-row col-form-label">
        <label for="inputPartOfProgram" data-i18n="LABEL_NAME"></label>
      </div>
      <div class="form-row">
      <input type="text" class="form-control inputPartOfProgram" id="inputPartOfProgram" placeholder="Part of program"
        data-i18n-placeholder="LABEL_PROGRAM_PLACEHOLDER" value="${name}" required oninput="generate()" />
      <div class="valid-feedback"></div>
      <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
      </div>
    </div>

    <div class="form-group">
      <div class="form-row col-form-label">
        <label for="inputPartOfProgramId" data-i18n="LABEL_PROGRAM_ID"></label>
      </div>
      <div class="form-row">
      <div class="valid-feedback"></div>
      <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
      <input type="text" class="form-control inputPartOfProgramId" id="inputPartOfProgramId" placeholder="ID" value="${id}" oninput="generate()" />
      </div>
    </div>

    <div class="form-group">
      <div class="form-row col-form-label">
        <label for="inputPartOfProgramAbbreviation" data-i18n="LABEL_PROGRAM_ABBREVIATION"></label>
      </div>
      <div class="form-row">
      <div class="valid-feedback"></div>
      <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
      <input type="text" class="form-control inputPartOfProgramAbbreviation" id="inputPartOfProgramAbbreviation" placeholder="Abbreviation"
      data-i18n-placeholder="LABEL_PROGRAM_ABBREVIATION_PLACEHOLDER" value="${abbreviation}" oninput="generate()" />
      </div>
    </div>

    <div class="form-group">
      <div class="form-row col-form-label">
        <label for="inputPartOfProgramDescription" data-i18n="LABEL_PROGRAM_DESCRIPTION"></label>
      </div>
      <div class="form-row">
        <textarea class="form-control inputPartOfProgramDescription" id="inputPartOfProgramDescription" placeholder="Beschreibung"
        data-i18n-placeholder="LABEL_PROGRAM_DESCRIPTION_PLACEHOLDER" oninput="generate()">${description}</textarea>
        <div class="valid-feedback"></div>
        <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
      </div>
    </div>

    <div class="form-group">
        <label for="programTeachingLanguage" class="form-row col-form-label" data-i18n="LABEL_TEACHING_LANGUAGE">Sprache</label>
        <div class="form-row">
          <select data-style="input-dropdown" data-width="100%" class="selectpicker" id="programTeachingLanguage" data-i18n-title="LABEL_CHOOSE" value="${teachingLanguage}">
            ${options}
          </select>
          <div class="valid-feedback"></div>
          <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
        </div>
      </div>

    <div class="form-row mt-2">
      <div class="col">
        <button type="button" onclick="removeListItem(this.parentNode.parentNode.parentNode)" class="btn btn-primary"><i class="fa fa-minus"></i> <span data-i18n="LABEL_REMOVE"> entfernen</span></button>
      </div>
    </div>
    `;
    
    programList.insertBefore(item, programList.lastElementChild);
    programList.querySelector("#programTeachingLanguage").value = teachingLanguage;
    $("#programTeachingLanguage").selectpicker("refresh");

    updateContent();
  }

  function getPrograms() {
    const programElement = document.getElementById("program-list").querySelectorAll(".list-group-item");
    const programs = [];
    for (let i = 0; i < programElement.length - 1; i++) {
      let name = programElement[i].getElementsByClassName("inputPartOfProgram")[0].value.trim();
      let id = programElement[i].getElementsByClassName("inputPartOfProgramId")[0].value.trim();
      let abbreviation = programElement[i].getElementsByClassName("inputPartOfProgramAbbreviation")[0].value.trim();
      let description = programElement[i].getElementsByClassName("inputPartOfProgramDescription")[0].value.trim();
      let teachingLanguage = $('#programTeachingLanguage').val();

      if (name) {
        programs.push({
          name: name,
          programType: "program",
          description: description,
          abbreviation: abbreviation,
          teachingLanguage: teachingLanguage ? [teachingLanguage] :  null,
          primaryCode: id ? {
            codeType: "programCode",
            code: id
          } : null
        })
      }
    }
    return programs;
  }

  function addResource(value="") {
    const resourceList = document.getElementById("resource-list");
    const item = document.createElement("li");
    item.setAttribute("class", "list-group-item");

    item.innerHTML = `
      <input type="text" class="form-control inputResource" id="inputResource" placeholder="Ressource"
      data-i18n-placeholder="LABEL_RESOURCE" value="${value}" oninput="generate()" />

      <div class="form-row mt-2">
        <div class="col">
          <button type="button" onclick="removeListItem(this.parentNode.parentNode.parentNode)" class="btn btn-primary"><i class="fa fa-minus"></i> <span data-i18n="LABEL_RESOURCE_REMOVE">Ressource entfernen</span></button>
        </div>
      </div>
    `;
    resourceList.insertBefore(item, resourceList.lastElementChild);
    updateContent();
  }

  function getResources() {
    const resourcesElement = document.getElementById("resource-list").querySelectorAll(".list-group-item");
    const resources = [];
    for (let i = 0; i < resourcesElement.length - 1; i++) {
        let value = resourcesElement[i].getElementsByClassName("inputResource")[0].value.trim();
        if (value != "") resources.push(value);
    }
    return resources;
  }

  function addOrganization(institution = "", organizationName = "", type = "Organization", affiliationName = "") {
    const organizationList = document.getElementById("organization-list");
    const item = document.createElement("li");
    item.setAttribute("class", "list-group-item organization-list-item");

    let institutionOptions = "";
    let organizationOptions = "";
    $.each(vocabInstitutions, function (i, item) {
      institutionOptions += '<option value="' + item["ror"] + '"' + (item["ror"] === institution ? ' selected' : '') + '>' + item["label"] + '</option>';
      organizationOptions += '<option value="' + item["ror"] + '"' + (item["ror"] === institution ? ' selected' : '') + '>' + item["label"] + '</option>';
    });
    if (institution?.length > 0 && !vocabInstitutions.find((e) => e["ror"] === institution)) {
      if (affiliationName?.length > 0) {
        institutionOptions += '<option value="' + institution + '"' + ' selected>' + affiliationName + '</option>';
      }
      if (organizationName?.length > 0) {
        organizationOptions += '<option value="' + institution + '"' + ' selected>' + organizationName + '</option>';
      }
    }
    let customInstitutionSelected = institution === "" && affiliationName !== "";
    let customOrganizationSelected = institution === "" && organizationName !== "";
    let radioGroupName = organizationList.childElementCount;
    radioGroupName += 'x'

    item.innerHTML = `
    <div class="inner-list-group-item mb-3">
      <div class="form-row organization-element">
        <div class="col-1 m-auto" style="flex-basis: content">
          <input class="organizationType" type="radio" name="organization_${radioGroupName}" id="organizationTypeStandard" aria-label="radio button for organization list" ${customOrganizationSelected ? "":"checked"} value="standard" onclick="changeOrganizationType(this.parentNode.parentNode.parentNode, 'standard')" oninput="generate()">
        </div>
        <div class="col-11 mb-1" id="select-div">
          <select ${customOrganizationSelected ? "disabled":""}  data-style="input-dropdown" data-width="100%" class="form-select inputOrganization select-organization" id="organization-select">
            <option value="" data-i18n="LABEL_ORGANIZATION_CHOOSE" ${institution === "" ? "selected":""}></option>
            ${organizationOptions}
          </select>
        </div>
      </div>
      <div class="form-row organization-element">
        <div class="col-1 m-auto" style="flex-basis: content">
          <input class="organizationType" type="radio" name="organization_${radioGroupName}" id="organizationTypeCustom" aria-label="radio button for organization list" ${customOrganizationSelected ? "checked":""} value="custom" onclick="changeOrganizationType(this.parentNode.parentNode.parentNode, 'custom')">
        </div>
          <div class="col-11">
            <input type="text" ${customOrganizationSelected ? "":"disabled"} class="form-control customOrganization inputOrganization" placeholder="Institution" data-i18n-placeholder="LABEL_CUSTOM_INSTITUTION" oninput="generate()" value="${customOrganizationSelected ? organizationName:""}">
          </div>
        </div>
      </div>
    </div>
    <div class="inner-list-group-item">
      <div class="form-row organization-element mt-3">
        <div class="col m-auto">
          <button type="button" onclick="console.log(this.parentNode); removeListItem(this.parentNode.parentNode.parentNode.parentNode)" class="btn btn-primary"><i class="fa fa-minus"></i> <span data-i18n="LABEL_REMOVE"></span></button>
        </div>
      </div>
    </div>
    `;

    organizationList.insertBefore(item, organizationList.lastElementChild);
    addSubOrganizationButtons(item);
    createOrUpdateSelectInputAffiliation();
    createOrUpdateSelectOrganization();
    createOrUpdateDatePicker();
    updateContent();
  }

  function addSubOrganizationButtons(parentNode) {
    const organizationList = document.getElementById("organization-list");
    const organizationElement = organizationList.getElementsByClassName("inner-list-group-item");
    const item = document.createElement("div");
    item.setAttribute("class", "mt-3 inner-list-group-item suborganization-list");

    let html = `<div class="form-row m-auto" style="flex: 1; column-gap: 10px;">`;
    subOrganizationTypes.forEach(item => {
       html += `<button type="button" onclick="addSubOrganization('', '${item}', this.parentNode.parentNode)" class="btn btn-primary"><i class="fa fa-plus"></i> <span
              data-i18n="${item}">${item}</span></button>`
    });
    html += `</div>`;
    item.innerHTML = html;
    parentNode.insertBefore(item, parentNode.lastElementChild);
    updateContent();
  }

  function addSubOrganization(subOrganizationName = "", subOrganizationType = "", organizationElement = "") {
    const item = document.createElement("li");
    item.setAttribute("class", "list-group-item");

    item.innerHTML = `
    <div class="form-row">
      <div class="col-sm-2 col-form-label">
        <label for="inputSubOrganization" data-i18n="${i18next.t(subOrganizationType)}"></label>
      </div>
      <div class="col">
        <input type="text" class="form-control inputSubOrganization" id="inputSubOrganization" placeholder="${i18next.t(subOrganizationType)}"
          data-i18n-placeholder="${i18next.t(subOrganizationType)}" value="${subOrganizationName}" oninput="generate()" />
        <input type="text" class="form-control inputSubOrganization" id="inputSubOrganization" value=${subOrganizationType} hidden />
      </div>
    </div>

    <div class="form-row mt-2">
      <div class="col">
        <button type="button" onclick="removeListItem(this.parentNode.parentNode.parentNode)" class="btn btn-primary"><i class="fa fa-minus"></i> <span data-i18n="LABEL_REMOVE"> entfernen</span></button>
      </div>
    </div>
    `;

    organizationElement.parentNode.insertBefore(item, organizationElement)
    createOrUpdateSelectInputAffiliation();
    createOrUpdateSelectOrganization();
    createOrUpdateDatePicker();
    updateContent();
  }

  function addLocation(street = "", streetNumber = "", postalCode = "", city = "", country = "") {
    const locationList = document.getElementById("location-list");
    const item = document.createElement("li");
    item.setAttribute("class", "list-group-item");

    item.innerHTML = `
    <div class="form-row mt-1 person-element">
      <div class="col-sm-auto" style="flex-grow: 2;">
        <input type="text" class="form-control inputStreet" id="inputStreet" placeholder="Straße" data-i18n-placeholder="LABEL_STREET" oninput="generate()" value=${street}></textarea>
      </div>
      <div class="col-sm-auto" style="flex-grow: 1;">
        <input type="text" class="form-control inputStreetNumber" id="inputStreetNumber" placeholder="Hausnummer" data-i18n-placeholder="LABEL_STREET_NUMBER" oninput="generate()" value=${streetNumber} ></textarea>
      </div>
    </div>

    <div class="form-row mt-3 person-element">
      <div class="col-sm-auto" style="flex-grow: 1;">
        <input type="text" class="form-control inputPostalCode" id="inputPostalCode" placeholder="PLZ" data-i18n-placeholder="LABEL_POSTALCODE" oninput="generate()" value=${postalCode}></textarea>
      </div>
      <div class="col-sm-auto" style="flex-grow: 2;">
        <input type="text" class="form-control inputCity" id="inputCity" placeholder="Stadt" data-i18n-placeholder="LABEL_CITY" oninput="generate()" value=${city}></textarea>
      </div>
      <div class="col-sm-auto" style="flex-grow: 2;">
        <input type="text" class="form-control inputCountry" id="inputCountry" placeholder="Land" data-i18n-placeholder="LABEL_COUNTRY" oninput="generate()" value=${country}></textarea>
      </div>
    </div>

    <div class="form-row mt-3">
      <div class="col-auto">
        <button type="button" onclick="removeListItem(this.parentNode.parentNode.parentNode)" class="btn btn-primary"><i class="fa fa-minus"></i> <span data-i18n="LABEL_REMOVE"> Ort entfernen</span></button>
      </div>
    </div>
    `;

    locationList.insertBefore(item, locationList.lastElementChild);
    updateContent();
  }

  function getLocations() {
    const locationElement = document.getElementById("location-list").querySelectorAll(".list-group-item");
    const locations = [];
    
    for (let i = 0; i < locationElement.length - 1; i++) {
      let street = locationElement[i].getElementsByClassName("inputStreet")[0].value.trim();
      let streetNumber = locationElement[i].getElementsByClassName("inputStreetNumber")[0].value.trim();
      let postalCode = locationElement[i].getElementsByClassName("inputPostalCode")[0].value.trim();
      let city = locationElement[i].getElementsByClassName("inputCity")[0].value.trim();
      let country = locationElement[i].getElementsByClassName("inputCountry")[0].value.trim(); // TODO country code; select instead of text input

      let address = {
        addressType: "postal",
        }
      if (street) address["street"] = street;
      if (streetNumber) address["streetNumber"] = streetNumber;
      if (postalCode) address["postalCode"] = postalCode;
      if (city) address["city"] = city;
      if (country) address["country"] = country;
      locations.push(address);
      
    }
    
    return locations;
  }

  function addCoordinator(firstName = "", lastName = "", primaryCode = {}, type = "Person") {
    const coordinatorList = document.getElementById("coordinator-list");
    const item = document.createElement("li");
    const code = primaryCode?.code ? primaryCode.code : "";
    const codeType = primaryCode?.codeType ? primaryCode.codeType : "";
    item.setAttribute("class", "list-group-item");
    let radioGroupName = coordinatorList.childElementCount > 1 ? $(coordinatorList.lastElementChild.previousElementSibling).find('.inputType').find('input').attr('name') : ''
    radioGroupName += 'x'

    item.innerHTML = `
    <div class="form-row person-element">
      <div class="col">
        <label for="inputGivenName" data-i18n="LABEL_COORDINATOR_GIVEN_NAME">First name</label>
        <input type="text" class="form-control inputGivenName" placeholder="Vorname" data-i18n-placeholder="LABEL_COORDINATOR_GIVEN_NAME" value="${firstName}" oninput="generate()">
          <div class="valid-feedback"></div>
          <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
      </div>
      <div class="col">
        <label for="inputFamilyName" data-i18n="LABEL_COORDINATOR_LAST_NAME">Last name</label>
        <input type="text" class="form-control inputFamilyName" placeholder="Nachname" data-i18n-placeholder="LABEL_COORDINATOR_LAST_NAME" value="${lastName}" oninput="generate()">
          <div class="valid-feedback"></div>
          <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
      </div>
    </div>
    <div class="form-row row mt-2 person-element">
      <div class="col">
        <label for="inputAuthorId" data-i18n="LABEL_COORDINATOR_ID">Personal ID</label>
        <input type="url" class="form-control inputAuthorId" placeholder="Persönliche ID (optional, wie ORCID, GND)" data-i18n-placeholder="LABEL_COORDINATOR_ID_PLACEHOLDER" value="${code}" oninput="generate()">
      </div>
    </div>

    <div class="form-row mt-3">
      <div class="col">
        <button type="button" onclick="removeListItem(this.parentNode.parentNode.parentNode)" class="btn btn-primary"><i class="fa fa-minus"></i> <span data-i18n="LABEL_COORDINATOR_REMOVE"> Autor entfernen</span></button>
      </div>
    </div>
    `;

    coordinatorList.insertBefore(item, coordinatorList.lastElementChild);

    createOrUpdateSelectInputAffiliation();
    createOrUpdateSelectOrganization();
    createOrUpdateDatePicker();
    updateContent();
  }

  function addUnit(name = "", description = "", resources = []) {
    const unitList = document.getElementById("unit-list");
    const item = document.createElement("li");
    item.setAttribute("class", "list-group-item unit-list-item");

    let options = $("#teachingLanguage").html();

    item.innerHTML = `    
    <div class="form-group">
      <div class="form-row col-form-label">
        <label for="inputUnitName" data-i18n="LABEL_NAME"></label>
      </div>
      <div class="form-row">
      <input type="text" class="form-control inputUnitName" id="inputUnitName" placeholder="Name"
        data-i18n-placeholder="LABEL_UNIT_NAME_PLACEHOLDER" value="${name}" required oninput="generate()" />
      <div class="valid-feedback"></div>
      <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
      </div>
    </div>

    <div class="form-group">
      <div class="form-row col-form-label">
        <label for="inputUnitDescription" data-i18n="LABEL_DESCRIPTION"></label>
      </div>
      <div class="form-row">
        <textarea class="form-control inputUnitDescription" id="inputUnitDescription" placeholder="Beschreibung"
        data-i18n-placeholder="LABEL_UNIT_DESCRIPTION_PLACEHOLDER" oninput="generate()">${description}</textarea>
        <div class="valid-feedback"></div>
        <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
      </div>
    </div>

    <div class="form-group mt-2">
      <div class="form-row col-form-label">
        <label for="inputUnitResource" data-i18n="LABEL_RESOURCE"></label>
      </div>
      <ul class="list-group form-row" id="unit-resource-list">
        <li class="list-group-item">
          <div class="form-row">
            <button type="button" onclick="addUnitResource(this.parentNode.parentNode.parentNode.parentNode)" class="btn btn-primary"><i class="fa fa-plus"></i> <span data-i18n="LABEL_RESOURCE_ADD">Ressource hinzufügen</span></button>
          </div>
        </li>
      </ul>
      <div class="valid-feedback"></div>
      <div class="invalid-feedback" data-i18n="LABEL_MANDATORY_FIELD">Pflichtfeld</div>
    </div>

    <div class="form-row mt-2">
      <div class="col">
        <button type="button" onclick="removeListItem(this.parentNode.parentNode.parentNode)" class="btn btn-primary"><i class="fa fa-minus"></i> <span data-i18n="LABEL_REMOVE"> entfernen</span></button>
      </div>
    </div>
    `;
    
    unitList.insertBefore(item, unitList.lastElementChild);
    
    if (resources) {
      for (let i = 0; i < resources.length; i++) {
        addUnitResource(item, resources[i]);
      }
    }
    updateContent();
  }

  function addUnitResource(unitElement = "", resource = "") {
    const parent = unitElement.querySelector("#unit-resource-list");

    const item = document.createElement("li");
    item.setAttribute("class", "list-group-item");

    item.innerHTML = `
    <div class="col">
      <input type="text" class="form-control inputUnitResource" id="inputUnitResource" placeholder="Ressource"
      data-i18n-placeholder="LABEL_RESOURCE" value="${resource}" oninput="generate()" />

      <div class="form-row mt-2">
        <div class="col">
          <button type="button" onclick="removeListItem(this.parentNode.parentNode.parentNode.parentNode)" class="btn btn-primary"><i class="fa fa-minus"></i> <span data-i18n="LABEL_RESOURCE_REMOVE">Ressource entfernen</span></button>
        </div>
      </div>
    </div>
    `;

    parent.append(item, parent.lastElementChild);
    createOrUpdateSelectInputAffiliation();
    createOrUpdateSelectOrganization();
    createOrUpdateDatePicker();
    updateContent();
  }

  function getUnits() {
    const unitsElement = document.getElementById("unit-list").querySelectorAll(".unit-list-item");
    let units = [];
    for (let i = 0; i < unitsElement.length; i++) {
      let unit = {};
      let name = unitsElement[i].getElementsByClassName("inputUnitName");
      if (name.length > 0 && name[0].value.trim() != "") {
        unit["name"] = name[0].value.trim();
      } else continue;
      let description = unitsElement[i].getElementsByClassName("inputUnitDescription");
      if (description.length > 0 && description[0].value.trim() != "") {
        unit["description"] = description[0].value.trim();
      }
      let resources = unitsElement[i].getElementsByClassName("inputUnitResource");
      if (resources.length > 0) unit["resources"] = [];
      for (let j = 0; j < resources.length; j++) {
        let resource = resources[j].value.trim();
        if (resource) unit["resources"].push(resource);
      }
      if (!$.isEmptyObject(unit)) {
        units.push(unit);
      }
    }
    return units;
  }

  function setUnits(units) {
    const unitsElement = document.getElementById("unit-list").querySelectorAll(".list-group-item");
    removeListItem(unitsElement[0]);
    for (let i = 0; i < units.length; i++) {
      addUnit(units[i].name, units[i].description, units[i].resources);
    }
  }

  function removeListItem(listItem) {
    listItem.parentNode.removeChild(listItem);
    generate();
  }

  function getCoordinators() {
    const coordinatorsElement = document.getElementById("coordinator-list").querySelectorAll(".list-group-item");
    const coordinators = [];
    for (let i = 0; i < coordinatorsElement.length - 1; i++) {
      const coordinatorId = coordinatorsElement[i].getElementsByClassName("inputAuthorId")[0].value;
      let givenName = coordinatorsElement[i].getElementsByClassName("inputGivenName")[0].value.trim();
      let surname = coordinatorsElement[i].getElementsByClassName("inputFamilyName")[0].value.trim();
      coordinators.push({
        givenName: coordinatorsElement[i].getElementsByClassName("inputGivenName")[0].value.trim(),
        surname: coordinatorsElement[i].getElementsByClassName("inputFamilyName")[0].value.trim(),
        primaryCode: coordinatorId ? {
          codeType: String(coordinatorId).toLowerCase().includes("orcid") ? "orcId" : "identifier",
          code: coordinatorId 
        } : undefined
      });
    }
    return coordinators;
  }

  function copy_generated_output(text_element_id) {
    if (!navigator.clipboard) {
      return;
    }
    navigator.clipboard.writeText(document.getElementById(text_element_id).value).then(function() {
      $("#copied_to_clipboard_toast").toast("show");
    }, function(err) {
      console.error('Async: Could not copy text: ', err);
    });
  }

  function generate() {
    const language = userLang.substring(0,2).toLowerCase();
    const coordinators = getCoordinators();
    const organization = getOrganizations();
    const resources = getResources();
    const units = getUnits();
    const description = document.getElementById("inputDescription").value;
    const courseWorkload = document.getElementById("inputCourseWorkload").value;
    const selectedLanguages = $('#inputLanguage').val();
    const teachingLanguage = $('#teachingLanguage').val();
    const modeOfDelivery = $('#inputModeOfDelivery').val();
    const selectedSubjects = $('#inputSubjectOf').val();
    const selectedEducationalLevel = $('#inputEducationalLevel').val();
    const link = document.getElementById("inputUrl").value;
    const startDate = $("#startdatepicker").datepicker("getDate");
    const endDate = $("#enddatepicker").datepicker("getDate");
    const enrollEndDate = $("#enrollenddatepicker").datepicker("getDate");
    const studyLoad = $('#inputStudyLoad').val();
    const studyLoadUnit = $('#inputStudyLoadUnit').val();
    const learningOutcomes = document.getElementById('inputLearningOutcomes').value;
    const qualificationRequirements = document.getElementById('inputQualificationRequirements').value;
    const courseCode = $('#inputCourseCode').val();
    const courseType = $('#inputCourseType').val();
    const programs = getPrograms();
    const locations = getLocations();
    const audience = $('#inputAudience').val();
    const accessConditions = $('#inputAccessConditions').val();
    const freeAccess = document.getElementById("radioAccessFree").checked;
    const accessCost = $('#inputAccessCost').val();
    const accessCostCurrency = $('#inputAccessCostCurrency').val();

    let meta = {
      courseoffering: {
        name: [{
          language: language,
          value: document.getElementById("inputTitle").value
        }],
        course: {
          ext: {}
        },
        ext: {}
      },
    }
    if (description) {
      meta.courseoffering.description = [
        {
          language: language,
          value: description
        }
      ]
    }
    if (link) {
      meta.courseoffering.link = link;
    }
    if (courseCode) {
      meta.courseoffering.course.primaryCode = {
        codeType: "offeringCode",
        code: courseCode
      }
    }
    if (coordinators.length > 0) {
      meta.courseoffering.course.coordinators = coordinators;
    }
    if (organization) {
      meta.courseoffering.organization = organization;
    }
    if (modeOfDelivery) {
      meta.courseoffering.modeOfDelivery = [modeOfDelivery];
    }
    if (teachingLanguage && teachingLanguage.length > 0) {
      meta.courseoffering.teachingLanguage = languageCodes[teachingLanguage];
    }
    if (selectedSubjects.length > 0) {
      meta.courseoffering.course.fieldsOfStudy = selectedSubjects.split("/").slice(-1)[0];
    }
    if (selectedEducationalLevel.length > 0) {
      meta.courseoffering.course.level = selectedEducationalLevel
    }
    if (studyLoad) {
      meta.courseoffering.course.studyLoad = {
        studyLoadUnit: studyLoadUnit,
        value: studyLoad
      }
    }
    if (learningOutcomes) {
      let learningOutcome = {}
      learningOutcome[language] = learningOutcomes
      meta.courseoffering.course.learningOutcomes = [learningOutcome]
    }
    if (qualificationRequirements) {
      meta.courseoffering.course.qualificationRequirements = [{
        language: language,
        value: qualificationRequirements
      }]
    }
    if (courseWorkload) {
      meta.courseoffering.course.ext.courseWorkload = courseWorkload;
    }
    if (startDate) {
      let dateString = startDate.getFullYear() + "-"
                        + ('0' + (startDate.getMonth()+1)).slice(-2) + "-"
                        + ('0' + startDate.getDate()).slice(-2);
      meta.courseoffering.startDate = dateString;
    }
    if (endDate) {
      let dateString = endDate.getFullYear() + "-"
                        + ('0' + (endDate.getMonth()+1)).slice(-2) + "-"
                        + ('0' + endDate.getDate()).slice(-2);
      meta.courseoffering.endDate = dateString;
    }
    if (enrollEndDate) {
      let dateString = enrollEndDate.getFullYear() + "-"
                        + ('0' + (enrollEndDate.getMonth()+1)).slice(-2) + "-"
                        + ('0' + enrollEndDate.getDate()).slice(-2);
      meta.courseoffering.enrollEndDate = dateString;
    }
    if (startDate && endDate) {
      let duration_millis = endDate - startDate;
      let durationString = getDurationString(duration_millis);
      meta.courseoffering.course.duration = durationString;
    }
    if (document.getElementById("inputTags").value) {
      meta.courseoffering.ext.keywords = splitKeywords(document.getElementById("inputTags").value)
    }
    if (resources.length > 0) {
      meta.courseoffering.course.resources = resources;
    }
    if (programs) {
      meta.courseoffering.course.programs = programs;
    }
    if (courseType) {
      meta.courseoffering.course.ext.courseType = courseType;
    }
    if (locations.length > 0) {
      meta.courseoffering.course.addresses = locations;
    }
    if (audience) {
      meta.courseoffering.course.ext.audience = audience;
    }
    if (accessConditions) {
      meta.courseoffering.course.admissionRequirements = accessConditions;
    }
    if (freeAccess) {
      meta.courseoffering.priceInformation = {
        costType: "total costs",
        amount: 0,
        currency: "EUR"
      }
    } else if (accessCost) {
      meta.courseoffering.priceInformation = {
        costType: "total costs",
        amount: accessCost,
        currency: accessCostCurrency
      }
    }
    if (units) {
      meta.courseoffering.units = units;
    }

    document.getElementById("yaml_output").value = jsyaml.dump(meta);
    document.getElementById("json_output").value = JSON.stringify(meta, null, 2);
    if (navigator.clipboard) {
      document.getElementById("button_copy_generated_output_yaml").disabled = false
      document.getElementById("button_copy_generated_output_json").disabled = false
    }
  }

  function setCoordinators(coordinators) {
    const coordinatorsElement = document.getElementById("coordinator-list").querySelectorAll(".list-group-item");
    for (let i = 0; i < coordinatorsElement.length - 1; i++) {
      removeListItem(coordinatorsElement[i]);
    }
    for (let i = 0; i < coordinators.length; i++) {      
      const firstName = coordinators[i].givenName ? coordinators[i].givenName : "";
      const lastName = coordinators[i].surname ? coordinators[i].surname: "";
      const primaryCode = coordinators[i].primaryCode ? coordinators[i].primaryCode : "";
      addCoordinator(firstName, lastName, primaryCode, "Person");
    }
  }

  function setOrganization(organizations) {
    let organizationElement = document.getElementById("organization-list").querySelectorAll(".organization-list-item");
    for (let i = 0; i < organizationElement.length; i++) {
      removeListItem(organizationElement[i]);
    }

    if (organizations) {
      for (let i = 0; i < organizations.length; i++) {
        let organization = organizations[i];
        let name = "";
        if ("en" in organization.name) {
          name = organization.name["en"].value;
        } else {
          name = organization.name[0].value;
        }
        let organizationType;
        if (organization.primaryCode?.code && organization.primaryCode?.code?.toLowerCase().includes("ror.org")) {
          organizationType = "standard";
        } else {
          organizationType = "custom";
        }

        addOrganization(organization.primaryCode?.code, name, organizationType);

        organizationElement = document.getElementById("organization-list").querySelectorAll(".organization-list-item");
        console.log(i, organizationElement[i]);

        if ("children" in organization) {
          organization["children"].forEach(subOrganization => {
            console.log(i, i, organizationElement[i].getElementsByClassName("suborganization-list")[0])
            addSubOrganization(subOrganization.name, subOrganization.organizationType, organizationElement[i].getElementsByClassName("suborganization-list")[0]);
          });      
        }
      }
    } else addOrganization();
  }

  function getOrganizations() {
    const organizationElement = document.getElementById("organization-list").children;
    let organizationList = [];

    for (i = 0; i < organizationElement.length - 1; i++) {
      const organizationTypeElement = organizationElement[i].querySelector("input.organizationType:checked");
      let organizationInput, organization;

      if ("custom" === organizationTypeElement.value) {
        organizationInput = organizationElement[i].getElementsByClassName("customOrganization")[0].value.trim();
        organization = organizationInput ? {
          name: organizationInput
        } : undefined;
      } else {
        organizationInput = organizationElement[i].querySelector("select.inputOrganization");
        organization = organizationInput ? {
          name: organizationInput.options[organizationInput.selectedIndex].innerHTML,
          id: organizationInput.value,
          organizationType: "root"
        } : undefined;
      }

      if (organization && organization.name !== i18next.t("LABEL_ORGANIZATION_CHOOSE")) {
        let output = {
          name: [{
            language: "en",
            value: organization.name
          }],
          organizationType: "root"
        }
        if (organization.id) {
          organizationId: organization.id,
          output["primaryCode"] = {
            codeType: "identifier",
            code: organization.id
          }
        }

        let subOrganizations = getSubOrganizations(organizationElement[i]);
        if (subOrganizations.length > 0) {
          output["children"] = [];
          subOrganizations.forEach((subOrganization) => {
              output["children"].push({
                "name": subOrganization.value,
                "organizationType": subOrganization.type,
                "parent": organization.id
              }
            );
          });
        }
        organizationList.push(output);
      }
    }
    return organizationList;
  }

  function getSubOrganizations(parentOrganizationElement) {
    let organizationElement = parentOrganizationElement.getElementsByClassName("inputSubOrganization");
    const subOrganizations = [];
    for (let i = 0; i < organizationElement.length; i+=2) {
        let elem = organizationElement[i];
        subOrganizations.push({value: elem.value.trim(), type: organizationElement[i+1].value});
    }
    return subOrganizations;
  }

  function setResources(resources) {
    const resourcesElement = document.getElementById("resource-list").querySelectorAll(".list-group-item");
    for (let i = 0; i < resourcesElement.length - 1; i++) {
      removeListItem(resourcesElement[i]);
    }
    for (let i = 0; i < resources.length; i++) {
      addResource(resources[i]);
    }
  }

  function setPrograms(programs) {
    const programsElement = document.getElementById("program-list").querySelectorAll(".list-group-item");
    for (let i = 0; i < programsElement.length - 1; i++) {
      removeListItem(programsElement[i]);
    }
    for (let i = 0; i < programs.length; i++) {
      addProgram(programs[i].name, programs[i].id, programs[i].abbreviation, programs[i].description, programs[i].teachingLanguage);
    }
  }

  function setLocations(locations) {
    const locationElement = document.getElementById("location-list").querySelectorAll(".list-group-item");
    for (let i = 0; i < locationElement.length - 1; i++) {
      removeListItem(locationElement[i]);
    }
    for (let i = 0; i < locations.length; i++) {
      addLocation(locations[i].street, locations[i].streetNumber, locations[i].postalCode, locations[i].city, locations[i].country);
    }
  }

  function getDurationString(duration_millis) {
    let hours = duration_millis / 1000 / 60 / 60;
    let days = hours / 24;
    let weeks = days / 7;
    let months = weeks / 4.3;
    let years = months / 12;
    let duration = {};

    if (weeks >= 1) {
      if (months >= 1) {
        if (years >= 1) {
          duration["years"] = Math.floor(years);
          duration["months"] = Math.floor(months - (duration["years"] * 12));
          duration["weeks"] = Math.floor(weeks - (duration["years"] * 12 * 4.3) - (duration["months"] * 4.3));
          duration["days"] = Math.floor(days - (7 * duration["weeks"]) - (7 * 4.3 * duration["months"]) - (7 * 4.3 * 12 * duration["years"]));
        } else {
          duration["months"] = Math.floor(months);
          duration["weeks"] = Math.floor(weeks - (duration["months"] * 4.3));
          duration["days"] = Math.floor(days - (7 * duration["weeks"]) - (4.3 * 7 * duration["months"]));
        }
      } else {
        duration["weeks"] = Math.floor(weeks);
        duration["days"] = days - (7 * duration["weeks"]);
      }
    } else {
      duration["days"] = days;
    }
    
    let durationString = "P";
    if (duration["years"]) durationString += duration["years"] + "Y";
    if (duration["months"]) durationString += duration["months"] + "M";
    if (duration["weeks"]) durationString += duration["weeks"] + "W";
    if (duration["days"]) durationString += duration["days"] + "D";
    return durationString;
  }

  function importData() {
    try {
      const idMap = (o) => (typeof o === 'string' || o instanceof String) ? o : o.id;
      const data = jsyaml.load(document.getElementById("importData").value);
      let aboutIds = [];
      if (data.courseoffering.course.fieldsOfStudy) {
        if (data.courseoffering.course.fieldsOfStudy.startsWith("https://")) {
          aboutIds = idMap(data.courseoffering.course.fieldsOfStudy);
        } else {
          aboutIds = "https://w3id.org/kim/hochschulfaechersystematik/" + data.courseoffering.course.fieldsOfStudy;
        }
        $('#inputSubjectOf').val(aboutIds).selectpicker('refresh');
      }
      const educationalLevelIds = data.courseoffering.course.level ? idMap(data.courseoffering.course.level) : [];
      const teachingLanguage = data.courseoffering.teachingLanguage ? Object.keys(languageCodes).find(key => languageCodes[key] === data.courseoffering.teachingLanguage) : [];
      $("#startdatepicker").datepicker("update", new Date(data.courseoffering.startDate));
      $("#enddatepicker").datepicker("update", new Date(data.courseoffering.endDate));
      $("#enrollenddatepicker").datepicker("update", new Date(data.courseoffering.enrollEndDate));
      document.getElementById("inputUrl").value = data.courseoffering.link ? data.courseoffering.link : "";
      document.getElementById("inputTitle").value = data.courseoffering.name[0].value;
      document.getElementById("inputTags").value = data.courseoffering.ext.keywords ? data.courseoffering.ext.keywords.join(", ") : "";
      document.getElementById("inputCourseType").value = data.courseoffering.course.ext.courseType ? data.courseoffering.course.ext.courseType : "";
      if (data.courseoffering.course.coordinators) {
        setCoordinators(data.courseoffering.course.coordinators);
      }
      if (data.courseoffering.organization) {
        setOrganization(data.courseoffering.organization)
      }
      if (data.courseoffering.resources) {
        setResources(data.courseoffering.resources);
      }
      if (data.courseoffering.units) {
        setUnits(data.courseoffering.units);
      }
      if (data.courseoffering.description)
        document.getElementById("inputDescription").value = data.courseoffering.description[0].value ? data.courseoffering.description[0].value : "";
      if (data.courseoffering.course.learningOutcomes && data.courseoffering.course.learningOutcomes.length > 0) {
        let learningOutcomes = String(data.courseoffering.course.learningOutcomes[0]["en"]);
        document.getElementById("inputLearningOutcomes").value = learningOutcomes.substring(learningOutcomes.indexOf(": "));
      }
      if (data.courseoffering.course.qualificationRequirements)
        document.getElementById("inputQualificationRequirements").value = data.courseoffering.course.qualificationRequirements[0].value ? data.courseoffering.course.qualificationRequirements[0].value : "";
      $('#teachingLanguage').val(teachingLanguage ? teachingLanguage : []).selectpicker('refresh');
      if (educationalLevelIds.length > 0) {
        $('#inputEducationalLevel').val(educationalLevelIds).selectpicker('refresh');
      }
      $('#inputModeOfDelivery').val(data.courseoffering.modeOfDelivery ? data.courseoffering.modeOfDelivery : []).selectpicker('refresh');
      if (data.courseoffering.course.studyLoad) {
        $('#inputStudyLoad').val(data.courseoffering.course.studyLoad.value);
        $('#inputStudyLoadUnit').val(data.courseoffering.course.studyLoad.studyLoadUnit.toLowerCase());
      }
      document.getElementById("inputCourseWorkload").value = data.courseoffering.course.ext.courseWorkload ? data.courseoffering.course.ext.courseWorkload : "";
      if (data.courseoffering.course.primaryCode) {
        document.getElementById("inputCourseCode").value = data.courseoffering.course.primaryCode.code;
      }
      if (data.courseoffering.course.programs) {
        setPrograms(data.courseoffering.course.programs);
      }
      if (data.courseoffering.course.addresses) {
        setLocations(data.courseoffering.course.addresses);
      }
      if (data.courseoffering.course.ext.audience) {
        $('#inputAudience').val(data.courseoffering.course.ext.audience).selectpicker('refresh');
      }
      if (data.courseoffering.course.admissionRequirements) {
        $('#inputAccessConditions') = data.courseoffering.course.admissionRequirements;
      }
    } catch (e) {
      console.warn(e);
      alert(i18next.t("LABEL_IMPORT_ERROR_MSG"));
    } finally {
      $('#importModal').modal('hide')
    }
  }

  function resetForm() {
    if (window.confirm(i18next.t("LABEL_CONFIRM_RESET"))) {
      document.getElementById("metadata-form").reset();
      $('#inputStudyLoadUnit').val("ects");
      $('#inputAccessCostCurrency').val("EUR");
      $('.selectpicker').on('change', function (e) {
        generate();
      });
      $('.selectpicker').selectpicker('refresh');
      setOrganization();
      generate();
    }
  }

  async function i18nLoader() {
    const langs = ["en", "de"];
    const jsons = await Promise.all(
      langs.map((l) => fetch("i18n/" + l + ".json").then((r) => r.json()))
    );
    const educationalLevelLabels = await Promise.all(
      langs.map((l) => fetch("i18n/educationalLevel-" + l + ".json").then((r) => r.json()))
    );
    const hcrt = await Promise.all(
      langs.map((l) => fetch("i18n/hcrt-" + l + ".json").then((r) => r.json()))
    );
    const languageLabels = await Promise.all(
      langs.map((l) => fetch("i18n/language-" + l + ".json").then((r) => r.json()))
    );
    const subjectLabels = await Promise.all(
      langs.map((l) => fetch("i18n/subject-" + l + ".json").then((r) => r.json()))
    );
    const modeOfDeliveryLabels = await Promise.all(
      langs.map((l) => fetch("i18n/modeOfDelivery-" + l + ".json").then((r) => r.json()))
    );
    const subOrganizationTypeLabels = await Promise.all(
      langs.map((l) => fetch("i18n/subOrganizationType-" + l + ".json").then((r) => r.json()))
    );
    const courseTypeLabels = await Promise.all(
      langs.map((l) => fetch("i18n/courseType-" + l + ".json").then((r) => r.json()))
    );
    const audienceLabels = await Promise.all(
      langs.map((l) => fetch("i18n/audience-" + l + ".json").then((r) => r.json()))
    );
    const res = langs.reduce((acc, l, idx) => {
      acc[l] = {translation: {...jsons[idx], ...educationalLevelLabels[idx], ...hcrt[idx], ...languageLabels[idx],
        ...subjectLabels[idx], ...modeOfDeliveryLabels[idx], ...subOrganizationTypeLabels[idx], ...courseTypeLabels[idx], ...audienceLabels[idx]}};
      return acc;
    }, {});
    await i18next.init({
      lng: "de",
      debug: false,
      nsSeparator: "#",
      resources: res,
      fallbackLng: 'en'
    });
    updateContent();
    i18next.on("languageChanged", () => {
      updateContent();
    });
  }
  function changeLanguage(languageCode) {
    userLang = languageCode;
    i18next.changeLanguage(languageCode);
    document.getElementById("selectedLanguageLabel").textContent = languageCode.toUpperCase();
    createOrUpdateSelectInputAffiliation();
    createOrUpdateSelectOrganization();
    createOrUpdateDatePicker();
    generate();
  }

  function createOrUpdateSelectOrganization() {
    $('.select-organization').select2({
      language: {
        noResults: () => i18next.t("LABEL_NO_INSTITUTION_FOUND")
      },
      placeholder: i18next.t("LABEL_ORGANIZATION_CHOOSE"),
      theme: "bootstrap",
      ajax: {
        url: 'https://api.ror.org/organizations?query=',
        data: function (params) {
          return {
            query: params.term,
            filter: "types:Education"
          }
        },
        processResults: function (data, params) {
          let results = [];

          if (params.term) {
            let localInstitutions = vocabInstitutions.map(institution => ({"name": institution["label"], "id": institution["ror"]}));
            let rorInstitutions = data["items"].map(institution => ({"name": institution.name, "id": institution.id}));

            let matchedLocalInstitutions = localInstitutions.filter(function(item) {
              return item.name.toLowerCase().includes(params.term.toLowerCase());
            });

            let filteredRorInstitutions = rorInstitutions.filter(function(item) {
              return !matchedLocalInstitutions.find(value => value.id == item.id);
            });

            results = [...matchedLocalInstitutions, ...filteredRorInstitutions];
          }

          return {
            results: $.map(results, function(item) {
              return {
                text: item.name,
                id: item.id
              }
            })
          }
        }
      }
    });
    $('.select-organization').on('select2:select', function (e) {
      generate();
    });
  }

  function createOrUpdateSelectInputAffiliation() {
    $('.select-institution').select2({
      language: {
        noResults: () => i18next.t("LABEL_NO_INSTITUTION_FOUND")
      },
      placeholder: i18next.t("LABEL_ORGANIZATION_CHOOSE"),
      theme: "bootstrap",
      ajax: {
        url: 'https://api.ror.org/organizations?query=',
        data: function (params) {
          return {
            query: params.term,
            filter: "types:Education"
          }
        },
        processResults: function (data, params) {
          let results = [];

          if (params.term) {
            let localInstitutions = vocabInstitutions.map(institution => ({"name": institution["label"], "id": institution["ror"]}));
            let rorInstitutions = data["items"].map(institution => ({"name": institution.name, "id": institution.id}));

            let matchedLocalInstitutions = localInstitutions.filter(function(item) {
              return item.name.toLowerCase().includes(params.term.toLowerCase());
            });

            let filteredRorInstitutions = rorInstitutions.filter(function(item) {
              return !matchedLocalInstitutions.find(value => value.id == item.id);
            });

            results = [...matchedLocalInstitutions, ...filteredRorInstitutions];
          }

          return {
            results: $.map(results, function(item) {
              return {
                text: item.name,
                id: item.id
              }
            })
          }
        }
      }
    });
  }

  function createOrUpdateDatePicker() {
    // Keep previously set date when changing the language
    let startDate = $('#startdatepicker').datepicker("getDate");
    let endDate = $('#enddatepicker').datepicker("getDate");
    let enrollEndDate = $('#enrollenddatepicker').datepicker("getDate");
    $('#startdatepicker').datepicker("destroy");
    $('#enddatepicker').datepicker("destroy");
    $('#enrollenddatepicker').datepicker("destroy");

    let language = document.getElementById("selectedLanguageLabel").textContent.toLowerCase();
    if (language == "en") language += "-US";

    $('#startdatepicker').datepicker({
      language: language
    });
    $('#enddatepicker').datepicker({
      language: language
    });
    $('#enrollenddatepicker').datepicker({
      language: language
    });

    $('#startdatepicker').datepicker().on("changeDate", function(e) {
      generate();
    });
    $('#enddatepicker').datepicker().on("changeDate", function(e) {
      generate();
    });
    $('#enrollenddatepicker').datepicker().on("changeDate", function(e) {
      generate();
    });

    if (startDate) {
      $('#startdatepicker').datepicker("update", new Date(startDate));
    }
    if (endDate) {
      $('#enddatepicker').datepicker("update", new Date(endDate));
    }
    if (enrollEndDate) {
      $('#enrollenddatepicker').datepicker("update", new Date(startDate));
    }
  }

  function updateContent() {
    let elements = document.querySelectorAll('[data-i18n]');
    for (let i = 0; i < elements.length; i++) {
      const element = elements[i];
      const k = element.getAttribute("data-i18n");
      element.innerHTML = i18next.t(k);
    }
    elements = document.querySelectorAll('[data-i18n-placeholder]');
    for (let i = 0; i < elements.length; i++) {
      const element = elements[i];
      const k = element.getAttribute("data-i18n-placeholder");
      element.setAttribute("placeholder", i18next.t(k));
    }
    $("[data-i18n-title]").each( function () {
      const k = $(this).attr("data-i18n-title")
      $(this).selectpicker({title: i18next.t(k)}).selectpicker('render');
    })
    $('.selectpicker').selectpicker('refresh');
  }
</script>

</body>
</html>
